unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ExtCtrls, StdCtrls, ZLIBArchive, ZLIBArchiveGlobals,
  rmBrowseFor, ActnList, rmDataStorage, rmZLIBDataStorage;

type
  TZLBArchiver1 = class(TForm)
    ZLB1: TZLBArchive;
    MainMenu1: TMainMenu;
    Panel1: TPanel;
    MELV1: TListView;
    Panel2: TPanel;
    ProgressBar1: TProgressBar;
    FileCountPnl: TStaticText;
    MsgPnl: TStaticText;
    Bevel1: TBevel;
    Bevel2: TBevel;
    ActionList1: TActionList;
    actSpacer: TAction;
    FileNew: TAction;
    FileOpen: TAction;
    FileClose: TAction;
    FileMakeExe: TAction;
    ActionsAdd: TAction;
    ActionsUpdate: TAction;
    ActionsExtract: TAction;
    ActionsDelete: TAction;
    FileExit: TAction;
    OptionsSavePath: TAction;
    OptionsExtractWithPath: TAction;
    OptionsCRC: TAction;
    OptionsCompression: TAction;
    OptionsCompressionNone: TAction;
    OptionsCompressionFastest: TAction;
    OptionsCompressionNormal: TAction;
    OptionsCompressionBest: TAction;
    OptionsCRCArchive: TAction;
    OptionsCRCFile: TAction;
    HelpAbout: TAction;
    ActionsRename: TAction;
    OptionsScanTree: TAction;
    File1: TMenuItem;
    Actions1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    RecurseChildFolders1: TMenuItem;
    SaveFilePath1: TMenuItem;
    ExtractFilePath1: TMenuItem;
    CompressionLevel1: TMenuItem;
    None1: TMenuItem;
    Fastest1: TMenuItem;
    Normal1: TMenuItem;
    Best1: TMenuItem;
    CRCChecks1: TMenuItem;
    VerifyArchive1: TMenuItem;
    VerifyFile1: TMenuItem;
    AddFiles1: TMenuItem;
    UpdateFiles1: TMenuItem;
    RenameFile1: TMenuItem;
    DeleteFiles1: TMenuItem;
    ExtractFiles1: TMenuItem;
    New1: TMenuItem;
    FileOpen1: TMenuItem;
    FileClose1: TMenuItem;
    FileMakeExe1: TMenuItem;
    FileExit1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    Splitter1: TSplitter;
    Memo1: TMemo;
    rmZLIBDataStorage1: TrmZLIBDataStorage;
    OpenDialog1: TOpenDialog;
    procedure Exit1Click(Sender: TObject);
    procedure ZLB1ArchiveOpened(Sender: TObject);
    procedure ZLB1ErrorLogged(Msg: string);
    procedure ZLB1Progress(Msg: string; Percentage: Integer);
    procedure FileNewExecute(Sender: TObject);
    procedure FileOpenExecute(Sender: TObject);
    procedure FileCloseExecute(Sender: TObject);
    procedure ActionsAddExecute(Sender: TObject);
    procedure ActionsUpdateExecute(Sender: TObject);
    procedure ActionsExtractExecute(Sender: TObject);
    procedure ActionsDeleteExecute(Sender: TObject);
    procedure ActionsRenameExecute(Sender: TObject);
    procedure FileExitExecute(Sender: TObject);
    procedure OptionsScanTreeExecute(Sender: TObject);
    procedure OptionsSavePathExecute(Sender: TObject);
    procedure OptionsExtractWithPathExecute(Sender: TObject);
    procedure OptionsCompressionNoneExecute(Sender: TObject);
    procedure OptionsCompressionFastestExecute(Sender: TObject);
    procedure OptionsCompressionNormalExecute(Sender: TObject);
    procedure OptionsCompressionBestExecute(Sender: TObject);
    procedure OptionsCRCFileExecute(Sender: TObject);
    procedure OptionsCRCArchiveExecute(Sender: TObject);
    procedure FileCloseUpdate(Sender: TObject);
    procedure FileMakeExeUpdate(Sender: TObject);
    procedure OptionsCRCUpdate(Sender: TObject);
    procedure OptionsCompressionUpdate(Sender: TObject);
    procedure OptionsCompressionExecute(Sender: TObject);
    procedure OptionsCRCExecute(Sender: TObject);
    procedure ActionsAddUpdate(Sender: TObject);
    procedure ActionsUpdateUpdate(Sender: TObject);
    procedure ActionsExtractUpdate(Sender: TObject);
    procedure ActionsDeleteUpdate(Sender: TObject);
    procedure ActionsRenameUpdate(Sender: TObject);
    procedure FileMakeExeExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ZLBArchiver1: TZLBArchiver1;

implementation

{$R *.DFM}

procedure TZLBArchiver1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TZLBArchiver1.ZLB1ArchiveOpened(Sender: TObject);
const
  FileStatusStr: array[TFileStatus] of string = ('Compressed', 'Stored');
  FileCompStr: array[TFileCompressionLevel] of string = ('None', 'Fastest', 'Normal', 'Maximum');
var
  loop: integer;
  lvItem: TListItem;
begin
  FileCountPnl.Caption := inttostr(ZLB1.FileCount) + ' File(s)';
  MsgPnl.Caption := ZLB1.ArchiveName;

  MELV1.Items.BeginUpdate;
  try
    MELV1.Items.Clear;
    loop := 0;
    while loop < ZLB1.FileCount do
    begin
      lvItem := MELV1.Items.Add;
      with lvItem do
      begin
        caption := ZLB1.Files[loop].name;
        subitems.Add(inttostr(ZLB1.Files[loop].osize));
        subitems.Add(inttostr(ZLB1.Files[loop].csize));
        subitems.Add(FileStatusStr[ZLB1.Files[loop].status]);
        subitems.Add(FileCompStr[ZLB1.Files[loop].CompressionLevel]);
        subitems.Add(inttohex(ZLB1.Files[loop].CRC, 8));
        subitems.add(inttostr(ZLB1.Files[loop].start));
        subitems.Add(ZLB1.Files[loop].path);
      end;
      inc(loop);
    end;
  finally
    MELV1.Items.EndUpdate;
  end;
end;

procedure TZLBArchiver1.ZLB1ErrorLogged(Msg: string);
begin
  Memo1.Lines.Add(msg);
end;

procedure TZLBArchiver1.ZLB1Progress(Msg: string; Percentage: Integer);
begin
  msgpnl.Caption := msg;
  msgpnl.Refresh;
  ProgressBar1.Position := Percentage;
end;

procedure TZLBArchiver1.FileNewExecute(Sender: TObject);
var
  ext: string;
  createdialog: TSaveDialog;
begin
  createdialog := TSaveDialog.create(self);
  try
    createdialog.Title := 'New ZLB Archive...';
    createdialog.Filter := 'ZLB Archive Files (*.zlb)|*.zlb|All Files (*.*)|*.*';
    createdialog.FilterIndex := 1;
    {$ifdef ver140}
       createDialog.OptionsEx := [ofExNoPlacesBar];
    {$endif}
    if createdialog.execute then
    begin
      if pos('.zlb', lowercase(extractfilename(createdialog.filename))) = 0 then
        ext := '.zlb'
      else
        ext := '';
      ZLB1.CreateArchive(createdialog.filename + ext);
    end;
  finally
    createdialog.free;
  end;
end;

procedure TZLBArchiver1.FileOpenExecute(Sender: TObject);
var
   OpenDialog : TOpenDialog;
begin
  OpenDialog := TOpenDialog.create(self);
  try
     OpenDialog.Title := 'Open ZLB Archive...';
     OpenDialog.Filter := 'ZLB Archive Files (*.zlb)|*.zlb|All Files (*.*)|*.*';
     OpenDialog.FilterIndex := 1;
     {$ifdef ver140}
        OpenDialog.OptionsEx := [ofExNoPlacesBar];
     {$endif}
     if OpenDialog.Execute then
       ZLB1.OpenArchive(OpenDialog.filename);
  finally
     OpenDialog.free;
  end;
end;

procedure TZLBArchiver1.FileCloseExecute(Sender: TObject);
begin
  MELV1.Items.Clear;
  ZLB1.CloseArchive;
end;

procedure TZLBArchiver1.ActionsAddExecute(Sender: TObject);
var
   AddDialog : TOpenDialog;
begin
  AddDialog := TOpenDialog.create(self);
  try
     AddDialog.Filter := 'All Files (*.*)|*.*';
     AddDialog.FilterIndex := 1;
     AddDialog.Title := 'Add File(s) to ' + extractfilename(zlb1.archivename);
     AddDialog.Options := [ofHideReadOnly,ofPathMustExist,ofFileMustExist,ofNoDereferenceLinks,ofEnableSizing,ofAllowMultiSelect,ofEnableSizing];
     {$ifdef ver140}
        AddDialog.OptionsEx := [ofExNoPlacesBar];
     {$endif}
     if AddDialog.Execute then
       ZLB1.AddFiles(AddDialog.files);
  finally
     AddDialog.free;
  end;
end;

procedure TZLBArchiver1.ActionsUpdateExecute(Sender: TObject);
var
   UpdateDialog : TOpenDialog;
begin
  UpdateDialog := TOpenDialog.create(self);
  try
     UpdateDialog.Filter := 'All Files (*.*)|*.*';
     UpdateDialog.FilterIndex := 1;
     UpdateDialog.Title := 'Update File(s) in ' + extractfilename(zlb1.archivename);
     UpdateDialog.Options := [ofHideReadOnly,ofPathMustExist,ofFileMustExist,ofNoDereferenceLinks,ofEnableSizing,ofAllowMultiSelect,ofEnableSizing];
     {$ifdef ver140}
        UpdateDialog.OptionsEx := [ofExNoPlacesBar];
     {$endif}
     if UpdateDialog.Execute then
       ZLB1.UpdateFiles(UpdateDialog.files);
  finally
     UpdateDialog.free;
  end;
end;

procedure TZLBArchiver1.ActionsExtractExecute(Sender: TObject);
var
  loop: integer;
  ExtractDialog : TrmBrowseForFolder;
begin
  if MELV1.SelCount = 0 then
    exit;
  ExtractDialog := TrmBrowseForFolder.create(self);
  try
     ExtractDialog.Title := 'Select folder to extract files to:';
     if ExtractDialog.Execute then
     begin
       loop := 0;
       while loop < MELV1.Items.Count do
       begin
         if MELV1.Items[loop].selected then
           ZLB1.ExtractFileByName(ExtractDialog.Folder, MELV1.Items[loop].SubItems.Strings[6] + MELV1.Items[loop].Caption);
         inc(loop);
       end;
     end;
  finally
     ExtractDialog.free;
  end;
end;

procedure TZLBArchiver1.ActionsDeleteExecute(Sender: TObject);
var
  filelist: tstringlist;
  loop: integer;
begin
  if MELV1.SelCount = 0 then
    exit;
  if messagedlg('Delete selected files from archive?', mtConfirmation, mbOKCancel, 0) = idok then
  begin
    filelist := tstringlist.create;
    try
      loop := 0;
      while loop < MELV1.items.count do
      begin
        if MELV1.items[loop].selected then
          filelist.Add(MELV1.items[loop].SubItems[6] + MELV1.items[loop].caption);
        inc(loop);
      end;
      ZLB1.DeleteFiles(filelist);
    finally
      filelist.free;
    end;
  end;
end;

procedure TZLBArchiver1.ActionsRenameExecute(Sender: TObject);
var
  name: string;
begin
  if MELV1.SelCount = 0 then
    exit;
  if Melv1.SelCount > 1 then
  begin
    messagedlg('You can only rename one file at a time', mtinformation, [mbok], 0);
  end
  else
  begin
    name := melv1.Selected.Caption;
    if InputQuery('Rename File', 'Please enter a new name:', name) then
    begin
      if (name <> '') and (ansilowercase(name) <> ansilowercase(melv1.Selected.Caption)) then
        zlb1.RenameFileByName(melv1.Selected.SubItems[6] + melv1.Selected.Caption, melv1.Selected.SubItems[6] + name);
    end;
  end;
end;

procedure TZLBArchiver1.FileExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TZLBArchiver1.OptionsScanTreeExecute(Sender: TObject);
begin
  zlb1.RecursePaths := not zlb1.RecursePaths;
  OptionsScanTree.Checked := zlb1.RecursePaths;
end;

procedure TZLBArchiver1.OptionsSavePathExecute(Sender: TObject);
begin
  zlb1.SavePaths := not zlb1.SavePaths;
  OptionsSavePath.Checked := zlb1.SavePaths;
end;

procedure TZLBArchiver1.OptionsExtractWithPathExecute(Sender: TObject);
begin
  ZLB1.ExtractWithPath := not ZLB1.ExtractWithPath;
  OptionsExtractWithPath.Checked := ZLB1.ExtractWithPath;
end;

procedure TZLBArchiver1.OptionsCompressionNoneExecute(Sender: TObject);
begin
  ZLB1.CompressionLevel := fcNone;
end;

procedure TZLBArchiver1.OptionsCompressionFastestExecute(Sender: TObject);
begin
  ZLB1.CompressionLevel := fcFastest;
end;

procedure TZLBArchiver1.OptionsCompressionNormalExecute(Sender: TObject);
begin
  ZLB1.CompressionLevel := fcDefault;
end;

procedure TZLBArchiver1.OptionsCompressionBestExecute(Sender: TObject);
begin
  ZLB1.CompressionLevel := fcMaximum;
end;

procedure TZLBArchiver1.OptionsCRCFileExecute(Sender: TObject);
begin
  ZLB1.VerifyFileCRC := not ZLB1.VerifyFileCRC;
  OptionsCRCFile.Checked := ZLB1.VerifyFileCRC;
end;

procedure TZLBArchiver1.OptionsCRCArchiveExecute(Sender: TObject);
begin
  ZLB1.VerifyArchiveCRC := not ZLB1.VerifyArchiveCRC;
  OptionsCRCArchive.Checked := ZLB1.VerifyArchiveCRC;
end;

procedure TZLBArchiver1.FileCloseUpdate(Sender: TObject);
begin
  FileClose.enabled := ZLB1.ArchiveName <> '';
end;

procedure TZLBArchiver1.FileMakeExeUpdate(Sender: TObject);
begin
  FileMakeExe.enabled := true;
end;

procedure TZLBArchiver1.OptionsCRCUpdate(Sender: TObject);
begin
  OptionsCRC.enabled := true;
end;

procedure TZLBArchiver1.OptionsCompressionUpdate(Sender: TObject);
begin
  OptionsCompression.Enabled := true;
end;

procedure TZLBArchiver1.OptionsCompressionExecute(Sender: TObject);
begin
//
end;

procedure TZLBArchiver1.OptionsCRCExecute(Sender: TObject);
begin
//
end;

procedure TZLBArchiver1.ActionsAddUpdate(Sender: TObject);
begin
  ActionsAdd.enabled := ZLB1.ArchiveName <> '';
end;

procedure TZLBArchiver1.ActionsUpdateUpdate(Sender: TObject);
begin
  ActionsUpdate.enabled := ZLB1.ArchiveName <> '';
end;

procedure TZLBArchiver1.ActionsExtractUpdate(Sender: TObject);
begin
  ActionsExtract.enabled := ZLB1.ArchiveName <> '';
end;

procedure TZLBArchiver1.ActionsDeleteUpdate(Sender: TObject);
begin
  ActionsDelete.enabled := ZLB1.ArchiveName <> '';
end;

procedure TZLBArchiver1.ActionsRenameUpdate(Sender: TObject);
begin
  ActionsRename.enabled := ZLB1.ArchiveName <> '';
end;

procedure TZLBArchiver1.FileMakeExeExecute(Sender: TObject);
var
   wstrm : TFileStream;
   wArchive : TFileStream;
   wFileName : string;
begin
   if OpenDialog1.execute then
   begin
      wArchive := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
      try
         wFileName := ChangeFileExt(OpenDialog1.FileName, '.exe');
         wstrm := TFileStream.create(wFileName, fmCreate);
         try
            rmZLIBDataStorage1.WriteToStream(wstrm);
            wstrm.CopyFrom(wArchive, 0);
         finally
            wstrm.free;
         end;
      finally
         wArchive.free;
      end;
      MessageDlg(ChangeFileExt(extractfilename(OpenDialog1.FileName),'')+' is now self-extracting.', mtInformation, [mbok], 0);
   end;
end;

end.

